## qmidiarp 0.0.2

=== Makefile ===
QT_BASE_DIR=/usr/lib/qt3
QT_LIB_DIR=$(QT_BASE_DIR)/lib
QT_BIN_DIR=$(QT_BASE_DIR)/bin
QT_INCLUDE_DIR=$(QT_BASE_DIR)/include
X11_LIB_DIR=/usr/X11R6/lib
X11_INCLUDE_DIR=/usr/X11R6/include

qmidiarp: gui.o gui.moc.o \
	arpwidget.o arpwidget.moc.o \
	midiarp.o midiarp.moc.o \
	arpdata.o arpdata.moc.o \
	slider.o slider.moc.o \
	seqdriver.o seqdriver.moc.o \
	logwidget.o logwidget.moc.o \
	passwidget.o passwidget.moc.o \
	groovewidget.o groovewidget.moc.o \
	main.o
	gcc -g -o qmidiarp \
	gui.o gui.moc.o \
	arpwidget.o arpwidget.moc.o \
	midiarp.o midiarp.moc.o \
	arpdata.o arpdata.moc.o \
	slider.o slider.moc.o \
	seqdriver.o seqdriver.moc.o \
	logwidget.o logwidget.moc.o \
	passwidget.o passwidget.moc.o \
	groovewidget.o groovewidget.moc.o \
	main.o \
	-L$(QT_LIB_DIR) -L$(X11_LIB_DIR) \
	-lqt-mt -lasound

CXXFLAGS=-I$(QT_INCLUDE_DIR) -I$(X11_INCLUDE_DIR) -I. -O2 -g -Wall

gui.o: gui.cpp gui.h arpdata.h logwidget.h passwidget.h arpwidget.h groovewidget.h slider.h
gui.moc.o: gui.moc.cpp gui.h arpdata.h logwidget.h passwidget.h arpwidget.h groovewidget.h slider.h
gui.moc.cpp: gui.h gui.cpp
	$(QT_BIN_DIR)/moc gui.h -o gui.moc.cpp
arpwidget.o: arpwidget.cpp arpwidget.h midiarp.h slider.h
arpwidget.moc.o: arpwidget.moc.cpp arpwidget.h midiarp.h slider.h
arpwidget.moc.cpp: arpwidget.h arpwidget.cpp
	$(QT_BIN_DIR)/moc arpwidget.h -o arpwidget.moc.cpp
midiarp.o: midiarp.cpp midiarp.h main.h
midiarp.moc.o: midiarp.moc.cpp midiarp.h main.h
midiarp.moc.cpp: midiarp.h midiarp.cpp
	$(QT_BIN_DIR)/moc midiarp.h -o midiarp.moc.cpp
arpdata.o: arpdata.cpp arpdata.h seqdriver.h arpwidget.h
arpdata.moc.o: arpdata.moc.cpp arpdata.h seqdriver.h
arpdata.moc.cpp: arpdata.h arpdata.cpp
	$(QT_BIN_DIR)/moc arpdata.h -o arpdata.moc.cpp
seqdriver.o: seqdriver.cpp seqdriver.h midiarp.h main.h
seqdriver.moc.o: seqdriver.moc.cpp seqdriver.h midiarp.h main.h
seqdriver.moc.cpp: seqdriver.h seqdriver.cpp
	$(QT_BIN_DIR)/moc seqdriver.h -o seqdriver.moc.cpp
logwidget.o: logwidget.cpp logwidget.h 
logwidget.moc.o: logwidget.moc.cpp logwidget.h
logwidget.moc.cpp: logwidget.h logwidget.cpp
	$(QT_BIN_DIR)/moc logwidget.h -o logwidget.moc.cpp
passwidget.o: passwidget.cpp passwidget.h 
passwidget.moc.o: passwidget.moc.cpp passwidget.h
passwidget.moc.cpp: passwidget.h passwidget.cpp
	$(QT_BIN_DIR)/moc passwidget.h -o passwidget.moc.cpp
groovewidget.o: groovewidget.cpp groovewidget.h slider.h
groovewidget.moc.o: groovewidget.moc.cpp groovewidget.h slider.h
groovewidget.moc.cpp: groovewidget.h groovewidget.cpp
	$(QT_BIN_DIR)/moc groovewidget.h -o groovewidget.moc.cpp
slider.o: slider.cpp slider.h
slider.moc.o: slider.moc.cpp slider.h
slider.moc.cpp: slider.h slider.cpp
	$(QT_BIN_DIR)/moc slider.h -o slider.moc.cpp
main.o: main.cpp gui.h main.h

## qmidiarp 0.4.2

=== debian/changelog ===
qmidiarp (0.4.2-1) unstable; urgency=low

  * New upstream release.
  * Remove patches, applied upstream.

 -- Alessio Treglia <alessio@debian.org>  Sun, 10 Jul 2011 11:32:28 +0200

qmidiarp (0.4.1-1) unstable; urgency=low

  * Imported Upstream version 0.4.1.
  * Build with scour for SVG optimizations.
  * Enable parall builds.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Wed, 01 Jun 2011 13:04:12 +0200

qmidiarp (0.3.9-1) unstable; urgency=low

  * Initial release. (Closes: #616544)

 -- Alessio Treglia <alessio@debian.org>  Sat, 05 Mar 2011 13:16:38 +0100

=== debian/control ===
Source: qmidiarp
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
 dh-autoreconf,
 libqt4-dev,
 libasound2-dev,
 libjack-dev,
 libx11-dev,
 python-scour
Homepage: http://qmidiarp.sourceforge.net/
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/pkg-multimedia/qmidiarp.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/qmidiarp.git

Package: qmidiarp
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Recommends: jackd
Description: MIDI arpeggiator for ALSA
 QMidiArp is an advanced MIDI arpeggiator, programmable step sequencer
 and LFO for the ALSA sequencer. It can hold any number of arpeggiator,
 sequencer, or LFO modules running in parallel.
 .
 Arpeggiator modules produce sequences depending on the notes sent
 to their input port, which is typically connected to a keyboard or
 another sequencer.
 .
 Step sequencer modules allow to create simple linear, monophonic
 and globally transposable sequences similar to the first analog
 sequencers.
 .
 MIDI LFO modules independently produce MIDI controller data of
 adjustable waveform, time resolution, amplitude and duration.
 .
 For each module, an input note filter is available, and the output
 port and channel can be set independently. Since the modules use a
 common sequencer queue, they are automatically in sync with each other.
 QMidiArp works with an internal tick resolution of 192 ticks per beat.
 The queue can be synchronized to an incoming MIDI realtime clock or as
 a JACK transport client. Most of the relevant control elements are
 accessible via MIDI controller through a MIDI-learn infrastructure.
 QMidiArp also has a log tool displaying the history of incoming MIDI
 events in colors depending on their type. QMidiArp is based on the Qt4
 toolkit

Package: qmidiarp-dbg
Section: debug
Priority: extra
Architecture: any
Depends: qmidiarp (= ${binary:Version}),
 ${misc:Depends}
Description: Debugging symbols for QMidiArp
 QMidiArp is an advanced MIDI arpeggiator, programmable step sequencer
 and LFO for the ALSA sequencer. It can hold any number of arpeggiator,
 sequencer, or LFO modules running in parallel.
 .
 This package contains the debugging symbols.

## qmidiarp 0.4.3

=== debian/changelog ===
qmidiarp (0.4.3-1) unstable; urgency=low

  [ Jaromír Mikeš ]
  * New upstream release.
  * Add myself as uploader.

  [ Alessio Treglia ]
  * Set DM-Upload-Allowed: yes

 -- Alessio Treglia <alessio@debian.org>  Sat, 03 Dec 2011 17:56:44 +0100

## qmidiarp 0.4.4

=== debian/changelog ===
qmidiarp (0.4.4-1) unstable; urgency=low

  * New upstream release:
    - New Features:
      + JACK MIDI backend doesn't require Jack Transport anymore
    - Improvements:
      + Better usability of the sequencer loop marker
      + Improved LFO offset slider behavior
      + Quantization to the minimum stepwidth in Arp modules active when
        changes in Arp patterns occur
    - Fixed Bugs
      + Crash on startup in JACK MIDI mode on certain systems
      + When cloning modules, the current play direction wasn't copied
      + Unmatched MIDI event forwarding didn't work with Arp modules
      + Typo in english manpage

 -- Alessio Treglia <alessio@debian.org>  Tue, 27 Dec 2011 02:10:30 +0100

=== debian/rules ===
#!/usr/bin/make -f

LDFLAGS+=-Wl,--as-needed

%:
	dh $@ --parallel --with=autoreconf,scour

override_dh_strip:
	dh_strip --dbg-package=qmidiarp-dbg

## qmidiarp 0.4.5

=== debian/changelog ===
qmidiarp (0.4.5-1) unstable; urgency=low

  * New upstream release.
    - Fixed Bugs
      + JACK Transport start with ALSA backend was broken in 0.4.4
      + Event forwarding port index was uninitialized in JACK MIDI backend

  * Added patch fixing desktop file
  * Added patch fixing few syntax and spelling errors in man pages

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 30 Jan 2012 23:41:28 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: sound
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
-Uploaders: Alessio Treglia <alessio@debian.org>
+Uploaders: Alessio Treglia <alessio@debian.org>,
+ Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends: debhelper (>= 7.0.50~),
  dh-autoreconf,
  libqt4-dev,
@@ -12,6 +13,7 @@
  python-scour
 Homepage: http://qmidiarp.sourceforge.net/
 Standards-Version: 3.9.2
+DM-Upload-Allowed: yes
 Vcs-Git: git://git.debian.org/pkg-multimedia/qmidiarp.git
 Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/qmidiarp.git

## qmidiarp 0.5.0

=== debian/changelog ===
qmidiarp (0.5.0-1) unstable; urgency=low

  * New upstream release.
  * Removed patches - applied upstream.
  * Bump Standards.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 28 Mar 2012 22:23:14 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libx11-dev,
  python-scour
 Homepage: http://qmidiarp.sourceforge.net/
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 DM-Upload-Allowed: yes
 Vcs-Git: git://git.debian.org/pkg-multimedia/qmidiarp.git
 Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/qmidiarp.git

## qmidiarp 0.5.1

=== debian/changelog ===
qmidiarp (0.5.1-1) experimental; urgency=low

  * New upstream release.
  * Set dh/compat 9.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 20 Nov 2012 00:16:49 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
-Build-Depends: debhelper (>= 7.0.50~),
+Build-Depends: debhelper (>= 9),
  dh-autoreconf,
  libqt4-dev,
  libasound2-dev,

## qmidiarp 0.5.2

=== debian/changelog ===
qmidiarp (0.5.2-1) unstable; urgency=low

  * New upstream release.
  * Fix VCS canonical URLs.
  * Remove obsolete DMUA.
  * Bump Standards.
  * Added liblo-dev as build dep.
  * Upload to unstable.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 09 May 2013 12:39:02 +0200

=== debian/control ===
--- 
+++ 
@@ -10,12 +10,12 @@
  libasound2-dev,
  libjack-dev,
  libx11-dev,
+ liblo-dev,
  python-scour
 Homepage: http://qmidiarp.sourceforge.net/
-Standards-Version: 3.9.3
-DM-Upload-Allowed: yes
-Vcs-Git: git://git.debian.org/pkg-multimedia/qmidiarp.git
-Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/qmidiarp.git
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/pkg-multimedia/qmidiarp.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/qmidiarp.git
 
 Package: qmidiarp
 Architecture: any

## qmidiarp 0.6.0

=== debian/changelog ===
qmidiarp (0.6.0-1) unstable; urgency=low

  * Imported Upstream version 0.6.0
  * Added lv2-dev as build dep.
  * Bump Standards.
  * Install upstream changelog.
  * Dont install *.la files.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 09 Jan 2014 15:22:27 +0100

qmidiarp (0.5.3-1) unstable; urgency=low

  * New upstream release.
  * Added keywords to desktop file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 27 Nov 2013 20:30:38 +0100

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends: debhelper (>= 9),
  dh-autoreconf,
+ lv2-dev,
  libqt4-dev,
  libasound2-dev,
  libjack-dev,
@@ -13,7 +14,7 @@
  liblo-dev,
  python-scour
 Homepage: http://qmidiarp.sourceforge.net/
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/qmidiarp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/qmidiarp.git

=== debian/watch ===
version=3
http://sf.net/qmidiarp/qmidiarp-(.*)\.tar\.bz2

## qmidiarp 0.6.1

=== debian/changelog ===
qmidiarp (0.6.1-1build1) wily; urgency=medium

  * No-change rebuild against libjack-jackd2-0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 11 Aug 2015 07:03:16 +0000

qmidiarp (0.6.1-1) unstable; urgency=low

  * Imported Upstream version 0.6.1
  * desktop file - Add mime type for Exec key.
  * desktop file - Fix Keywords syntax.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 25 Sep 2014 12:08:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: qmidiarp
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends: debhelper (>= 9),

## qmidiarp 0.6.3

=== debian/changelog ===
qmidiarp (0.6.3-1) unstable; urgency=medium

  * Imported Upstream version 0.6.3
  * Patch removed - applied upstream.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 04 Nov 2015 13:48:07 +0100

qmidiarp (0.6.2-1) unstable; urgency=medium

  * Imported Upstream version 0.6.2
  * Bump Standards.
  * Update copyright file.
  * Make watch file more flexible.
  * Fix description.
  * Patch forwarded.
  * Remove obsolete bz2 compression from gbp.conf file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 07 Oct 2015 06:48:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: qmidiarp
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends: debhelper (>= 9),
@@ -15,7 +14,7 @@
  liblo-dev,
  python-scour
 Homepage: http://qmidiarp.sourceforge.net/
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/qmidiarp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/qmidiarp.git
 
@@ -33,7 +32,7 @@
  to their input port, which is typically connected to a keyboard or
  another sequencer.
  .
- Step sequencer modules allow to create simple linear, monophonic
+ Step sequencer modules allow one to create simple linear, monophonic
  and globally transposable sequences similar to the first analog
  sequencers.
  .

=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,6 @@
 
 override_dh_strip:
 	dh_strip --dbg-package=qmidiarp-dbg
+
+override_dh_installchangelogs:
+	dh_installchangelogs NEWS

=== debian/watch ===
version=3
http://sf.net/qmidiarp/qmidiarp-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## qmidiarp 0.6.4

=== debian/changelog ===
qmidiarp (0.6.4-2) unstable; urgency=medium

  * Fix dh version.
  * Append LDFLAGS properly.
  * Install lv2 plugins properly. (Closes: #859479)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 04 Apr 2017 08:26:29 +0200

qmidiarp (0.6.4-1) unstable; urgency=medium

  * New upstream version 0.6.4
  * Bump Standards.
  * Fix VCS fields.
  * Set dh/compat 10.
  * Fix hardening.
  * Drop dbg package in favor of dbgsym.
  * Build with qt5.
  * Disable pie build flag to build with qt5.
  * Update copyright file.
  * Add upstream patch to fix issue with qt5.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 01 Nov 2016 18:14:03 +0100

=== debian/control ===
--- 
+++ 
@@ -4,19 +4,20 @@
 Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
  dh-autoreconf,
  lv2-dev,
- libqt4-dev,
+ qtbase5-dev,
+ qttools5-dev-tools,
  libasound2-dev,
  libjack-dev,
  libx11-dev,
  liblo-dev,
  python-scour
 Homepage: http://qmidiarp.sourceforge.net/
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/pkg-multimedia/qmidiarp.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/qmidiarp.git
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/qmidiarp.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/qmidiarp.git
 
 Package: qmidiarp
 Architecture: any
@@ -49,16 +50,3 @@
  QMidiArp also has a log tool displaying the history of incoming MIDI
  events in colors depending on their type. QMidiArp is based on the Qt4
  toolkit
-
-Package: qmidiarp-dbg
-Section: debug
-Priority: extra
-Architecture: any
-Depends: qmidiarp (= ${binary:Version}),
- ${misc:Depends}
-Description: Debugging symbols for QMidiArp
- QMidiArp is an advanced MIDI arpeggiator, programmable step sequencer
- and LFO for the ALSA sequencer. It can hold any number of arpeggiator,
- sequencer, or LFO modules running in parallel.
- .
- This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

export QT_SELECT=qt5

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with=autoreconf,scour

override_dh_auto_configure:
	dh_auto_configure -- --enable-qt5 --with-pic

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs NEWS

## qmidiarp 0.6.5

=== debian/changelog ===
qmidiarp (0.6.5-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:23:29 +0100

qmidiarp (0.6.5-3) unstable; urgency=medium

  * Team upload

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ Olivier Humbert ]
  * Update copyright (http -> https + bump 2019)

  [ Adrian Bunk ]
  * Build-depend on scour instead of python-scour (Closes: #943187)

  [ Sebastian Ramacher ]
  * debian/: Bump debhelper compat to 12
  * debian/control: Bump Standards-Version
  * debian/copyright: Document appdata license

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 24 Dec 2019 10:56:25 +0100

qmidiarp (0.6.5-2) unstable; urgency=medium

  * d/control:
    - long description: "Qt4" -> "Qt" (more generic)
    - missing punctuation
  * d/copyright:
    - add myself

 -- Olivier Humbert <trebmuh@tuxfamily.org>  Sun, 27 May 2018 12:22:30 +0200

qmidiarp (0.6.5-1) unstable; urgency=medium

  * New upstream version 0.6.5
  * Sign tags.
  * Use git instead of cgit in VCS.
  * Bump Standards.
  * Use secure uri where possible.
  * Introduce postclone.sh script to ignore .pc/ dir.
  * Patch removed - applied upstream.
  * Remove B-D on dh_autoreconf.
  * Build with Qt5 is now default.
  * Build with hardening pie now.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 17 Dec 2017 21:57:10 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT=qt5

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --with-pic

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
version=3
https://sf.net/qmidiarp/qmidiarp-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## qmidiarp 0.7.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(qmidiarp VERSION 0.7.0
        DESCRIPTION "MIDI arpeggiator, sequencer and LFO for ALSA and JACK"
        LANGUAGES C CXX)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

set (APP_NAME "QMidiArp")
set (PACKAGE "qmidiarp")
set (PACKAGE_NAME "qmidiarp")
set (PACKAGE_VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "emuse@users.sourceforge.net")
set (PACKAGE_STRING "${PACKAGE_NAME}-${PACKAGE_VERSION}")
set (PACKAGE_TARNAME "qmidiarp")
set (VERSION "${PROJECT_VERSION}")

if (CMAKE_BUILD_TYPE MATCHES "Debug")
    set(CONFIG_DEBUG 1)
else ()
    set(CONFIG_DEBUG 0)
endif ()

set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")
set (CONFIG_LV2DIR "${CMAKE_INSTALL_PREFIX}/lib/lv2")

include (GNUInstallDirs)
set (CONFIG_BINDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_BINDIR}")
set (CONFIG_LIBDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set (CONFIG_DATADIR "${CONFIG_PREFIX}/${CMAKE_INSTALL_DATADIR}")
set (CONFIG_MANDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_MANDIR}")

option (CONFIG_APPBUILD "Build QMidiArp Application (default=yes)" 1)
option (CONFIG_JACK_MIDI "Enable JACK MIDI support (default=yes)" 1)
option (CONFIG_ALSA_MIDI "Enable ALSA MIDI support (default=yes)" 1)

# Enable LV2 plugin build.
option (CONFIG_LV2 "Build LV2 plug-ins (default=yes)" 1)
option (CONFIG_LV2_UI "Build LV2 plug-in UIs with Qt (default=yes)" 1)
option (CONFIG_LV2_UI_RTK  "Build LV2 plug-in UIs with RobTk (default=yes)" 1)

# Enable NSM support.
option (CONFIG_NSM "Enable NSM support (default=yes)" 1)
set (APPBUILD ${CONFIG_APBUILD})

# Enable translations.
option (CONFIG_TRANSLATIONS "Build and install translations (default=no)" 1)
set (APPBUILD ${CONFIG_TRANSLATIONS})

# Fix for new CMAKE_REQUIRED_LIBRARIES policy.
if (POLICY CMP0075)
  cmake_policy (SET CMP0075 NEW)
endif ()

# Fix for CXX_VISIBILITY_PRESET policy.
if (POLICY CMP0063)
  cmake_policy (SET CMP0063 NEW)
  set (CMAKE_CXX_VISIBILITY_PRESET hidden)
  set (CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif ()

# Check for Qt
if (CONFIG_APPBUILD OR CONFIG_LV2_UI)
  find_package (QT NAMES Qt5 COMPONENTS Core REQUIRED)
  find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)
  # Check for lrelease translations
  if (CONFIG_TRANSLATIONS)
    find_program (CONFIG_LRELEASE NAMES "lrelease" DOC "lrelease executable location")
    if (NOT CONFIG_LRELEASE)
        set(CONFIG_TRANSLATIONS  0)
        message("Translation generation disabled, lrelease not found")
    else()
        find_program (CONFIG_LUPDATE NAMES "lupdate" DOC "lupdate executable location")
        message("lrelease found: ${CONFIG_LRELEASE}")
        message("Will build translations")
    endif()
  endif()
endif ()

#find_package (Qt${QT_VERSION_MAJOR}LinguistTools)

include (CheckIncludeFileCXX)
include (CheckIncludeFiles)
include (CheckIncludeFile)
include (CheckFunctionExists)
include (CheckLibraryExists)

# Checks for header files.
if (UNIX AND NOT APPLE)
  check_include_files ("fcntl.h;unistd.h;signal.h" HAVE_SIGNAL_H)
endif ()

# Find package modules
find_package (PkgConfig REQUIRED)

if (NOT CONFIG_APPBUILD)
  set (CONFIG_JACK_MIDI 0)
  set (CONFIG_ALSA_MIDI 0)
  set (CONFIG_NSM 0)
endif ()

    
# Check for liblo
if (CONFIG_NSM)
  pkg_check_modules (LIBLO IMPORTED_TARGET liblo)
  if (LIBLO_FOUND)
    include_directories (${LIBLO_INCLUDE_DIRS})
    link_directories (${LIBLO_LIBRARY_DIRS})
    link_libraries (${LIBLO_LIBRARIES})
    set (NSM 1)
  else ()
    message (WARNING "*** LIBLO library not found. Deactivating NSM support")
    set (CONFIG_LIBLO 0)
  endif ()
endif ()

# Check for JACK libraries.
if (CONFIG_APPBUILD)
  pkg_check_modules (JACK IMPORTED_TARGET jack>=0.100.0)
  if (JACK_FOUND)
    include_directories (${JACK_INCLUDE_DIRS})
    link_directories (${JACK_LIBRARY_DIRS})
  # link_libraries (${JACK_LIBRARIES})
    set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
    # Check for JACK MIDI headers availability.
    if (CONFIG_JACK_MIDI)
      check_include_files (jack/midiport.h HAVE_JACK_MIDIPORT_H)
      if (NOT HAVE_JACK_MIDIPORT_H)
        set (HAVE_JACK 0)
      else ()
        set (HAVE_JACK 1)
        set (APPBUILD 1)
      endif ()
    endif ()
    # Check for ALSA libraries.

    if (CONFIG_ALSA_MIDI)
      pkg_check_modules (ALSA IMPORTED_TARGET alsa)
      set (CONFIG_ALSA_MIDI ${ALSA_FOUND})
      if (CONFIG_ALSA_MIDI)
        include_directories (${ALSA_INCLUDE_DIRS})
        link_directories (${ALSA_LIBRARY_DIRS})
        link_libraries (${ALSA_LIBRARIES})
        set (HAVE_ALSA 1)
        set (APPBUILD 1)
        message ("Will build QMidiArp application")
      else ()
        set (HAVE_ALSA 0)
        if (NOT HAVE_JACK)
          set (APPBUILD 0)
            message (WARNING "*** Cannot build application without backend driver.")
        endif ()
        message (WARNING "*** ALSA library not found.")
      endif ()
    endif ()
  else ()
    message (WARNING "*** JACK library not found.")
    set (CONFIG_JACK 0)
  endif ()
endif ()

# Check for LV2 support.
if (CONFIG_LV2)
  pkg_check_modules (LV2 lv2)
  if (LV2_FOUND)
    include_directories (${LV2_INCLUDE_DIRS})
    link_directories (${LV2_LIBRARY_DIRS})
    link_libraries (${LV2_LIBRARIES})
    # Check for LV2 Atom support.
    check_include_file (lv2/lv2plug.in/ns/ext/atom/atom.h HAVE_LV2_ATOM_H)
    if (NOT HAVE_LV2_ATOM_H)
      set (CONFIG_LV2_ATOM 0)
    else ()
      set (CONFIG_LV2_ATOM 1)
      set (BUILD_LV2 1)
      message ("Will build LV2 plugins")
    endif ()
    set (CONFIG_LV2_ATOM_FORGE_OBJECT ${CONFIG_LV2_ATOM})
    set (CONFIG_LV2_ATOM_FORGE_KEY ${CONFIG_LV2_ATOM})
    # Check for LV2 UI support.
    check_include_file (lv2/lv2plug.in/ns/extensions/ui/ui.h HAVE_LV2_UI_H)
    if (NOT HAVE_LV2_UI_H)
      set (CONFIG_LV2_UI 0)
    else ()
      set (CONFIG_LV2_UI 1)
    endif ()
  else ()
    message (WARNING "*** LV2 headers not found.")
    set (CONFIG_LV2 0)
  endif ()
endif ()

if (CONFIG_LV2_UI_RTK)
  if(NOT EXISTS "${CMAKE_SOURCE_DIR}/robtk/ui_gl.c")
    set(CONFIG_LV2_UI_RTK, false)
    message(WARNING "*** robtk not found in source tree. Did you forget git submodule update --init ?")
    message("Will not build RTK LV2 UIs.")
  endif()
  pkg_check_modules (LV2 lv2)
  if (LV2_FOUND)
    include_directories (${LV2_INCLUDE_DIRS})
    link_directories (${LV2_LIBRARY_DIRS})
    link_libraries (${LV2_LIBRARIES})
    # Check for LV2 Atom support.
    check_include_file (lv2/lv2plug.in/ns/ext/atom/atom.h HAVE_LV2_ATOM_H)
    if (NOT HAVE_LV2_ATOM_H)
      set (CONFIG_LV2_ATOM 0)
    else ()
      set (CONFIG_LV2_ATOM 1)
      set (BUILD_LV2_UI_RTK 1)
    endif ()
    set (CONFIG_LV2_ATOM_FORGE_OBJECT ${CONFIG_LV2_ATOM})
    set (CONFIG_LV2_ATOM_FORGE_KEY ${CONFIG_LV2_ATOM})
    # Check for LV2 UI support.
    check_include_file (lv2/lv2plug.in/ns/extensions/ui/ui.h HAVE_LV2_UI_H)
    if (NOT HAVE_LV2_UI_H)
      set (CONFIG_LV2_UI_RTK 0)
    else ()
      set (CONFIG_LV2_UI_RTK 1)
    endif ()
  else ()
    message (WARNING "*** LV2 headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()

  pkg_check_modules (PANGO pango)
  if (PANGO_FOUND)
    include_directories (${PANGO_INCLUDE_DIRS})
    link_directories (${PANGO_LIBRARY_DIRS})
    link_libraries (${PANGO_LIBRARIES})
  else ()
    message (WARNING "*** PANGO headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
  
  pkg_check_modules (CAIRO cairo)
  if (PANGO_FOUND)
    include_directories (${CAIRO_INCLUDE_DIRS})
    link_directories (${CAIRO_LIBRARY_DIRS})
    link_libraries (${CAIRO_LIBRARIES})
  else ()
    message (WARNING "*** CAIRO headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
   
  pkg_check_modules (PANGOCAIRO pangocairo)
  if (PANGOCAIRO_FOUND)
    include_directories (${PANGOCAIRO_INCLUDE_DIRS})
    link_directories (${PANGOCAIRO_LIBRARY_DIRS})
    link_libraries (${PANGOCAIRO_LIBRARIES})
  else ()
    message (WARNING "*** PANGOCAIRO headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
  
  pkg_check_modules (GLU glu)
  if (GLU_FOUND)
    include_directories (${GLU_INCLUDE_DIRS})
    link_directories (${GLU_LIBRARY_DIRS})
    link_libraries (${GLU_LIBRARIES})
  else ()
    message (WARNING "*** GLU headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
  
  pkg_check_modules (GL gl)
  if (GL_FOUND)
    include_directories (${GL_INCLUDE_DIRS})
    link_directories (${GL_LIBRARY_DIRS})
    link_libraries (${GL_LIBRARIES})
  else ()
    message (WARNING "*** GL headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
endif ()

if (BUILD_LV2 AND CONFIG_LV2_UI AND QT_FOUND)
    message ("Will build LV2 UIs\n")
    set(BUILD_LV2_UI 1)
endif ()

if (BUILD_LV2 AND CONFIG_LV2_UI_RTK)
    message ("Will build RobTk LV2 UIs\n")
    set(BUILD_LV2_UI_RTK 1)
endif ()

add_subdirectory(src)
add_subdirectory(qmidiarp_arp.lv2)
add_subdirectory(qmidiarp_lfo.lv2)
add_subdirectory(qmidiarp_seq.lv2)

if (EXISTS ${CMAKE_SOURCE_DIR}/configure)
    set(ADD_AUTOCONF_FILES  --add-file=${CMAKE_SOURCE_DIR}/configure
                            --add-file=${CMAKE_SOURCE_DIR}/aclocal.m4
                            --add-file=${CMAKE_SOURCE_DIR}/compile
                            --add-file=${CMAKE_SOURCE_DIR}/config.guess
                            --add-file=${CMAKE_SOURCE_DIR}/config.sub
                            --add-file=${CMAKE_SOURCE_DIR}/depcomp
                            --add-file=${CMAKE_SOURCE_DIR}/install-sh
                            --add-file=${CMAKE_SOURCE_DIR}/ltmain.sh
                            --add-file=${CMAKE_SOURCE_DIR}/missing
                            --add-file=${CMAKE_SOURCE_DIR}/Makefile.in
                            --prefix=${PACKAGE_STRING}/m4/
                            --add-file=${CMAKE_SOURCE_DIR}/m4/libtool.m4
                            --add-file=${CMAKE_SOURCE_DIR}/m4/ltoptions.m4
                            --add-file=${CMAKE_SOURCE_DIR}/m4/ltsugar.m4
                            --add-file=${CMAKE_SOURCE_DIR}/m4/ltversion.m4
                            --add-file=${CMAKE_SOURCE_DIR}/m4/lt~obsolete.m4
                            --prefix=${PACKAGE_STRING}/man/
                            --add-file=${CMAKE_SOURCE_DIR}/man/Makefile.in
                            --prefix=${PACKAGE_STRING}/man/de/
                            --add-file=${CMAKE_SOURCE_DIR}/man//de/Makefile.in
                            --prefix=${PACKAGE_STRING}/man/fr/
                            --add-file=${CMAKE_SOURCE_DIR}/man//fr/Makefile.in
                            --prefix=${PACKAGE_STRING}/examples/
                            --add-file=${CMAKE_SOURCE_DIR}/examples/Makefile.in
                            --prefix=${PACKAGE_STRING}/src/
                            --add-file=${CMAKE_SOURCE_DIR}/src/config.h.in
                            --add-file=${CMAKE_SOURCE_DIR}/src/Makefile.in
                            --prefix=${PACKAGE_STRING}/src/pixmaps/
                            --add-file=${CMAKE_SOURCE_DIR}/src/pixmaps/Makefile.in
                            --prefix=${PACKAGE_STRING}/)

else ()
    set(ADD_AUTOCONF_FILES )
    message("Warning: No configure file found, will be missing when creating a dist archive")
endif ()

set(DIST_TARCOMMAND git --git-dir=${CMAKE_SOURCE_DIR}/.git archive 
                        --format=tar 
                        --prefix=${PACKAGE_STRING}/ ${ADD_AUTOCONF_FILES}
                        ${PACKAGE_STRING}^{tree} -o ${PACKAGE_STRING}.tar &&
                        git --git-dir=${CMAKE_SOURCE_DIR}/robtk/.git archive 
                        --format=tar 
                        --prefix=${PACKAGE_STRING}/robtk/ HEAD -o robtk.tar &&
                        tar --concatenate --file=${PACKAGE_STRING}.tar robtk.tar && 
                        rm -f robtk.tar)

add_custom_target(dist-bz2 COMMAND ${DIST_TARCOMMAND} && bzip2 -f ${PACKAGE_STRING}.tar )

=== src/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)


if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
    file(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
endif()

configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

if (APPBUILD)
    set (HEADERS
        cursor.h
        engine.h
        arpscreen.h
        lfoscreen.h
        seqscreen.h
        arpwidget.h
        lfowidget.h 
        seqwidget.h 
        groovewidget.h 
        mainwindow.h 
        globstore.h 
        indicator.h 
        modulewidget.h 
        logwidget.h 
        main.h 
        midiworker.h 
        midiarp.h 
        midilfo.h 
        midiseq.h 
        midicctable.h 
        midicontrol.h 
        midievent.h 
        nsm.h 
        driverbase.h 
        parstore.h 
        prefswidget.h 
        prefs.h 
        jackdriver.h 
        screen.h 
        seqdriver.h 
        slider.h 
        storagebutton.h
        )
    
    set( SOURCES
        cursor.cpp
        engine.cpp
        arpscreen.cpp
        lfoscreen.cpp
        seqscreen.cpp
        arpwidget.cpp
        lfowidget.cpp
        seqwidget.cpp
        groovewidget.cpp
        mainwindow.cpp
        globstore.cpp
        indicator.cpp
        modulewidget.cpp
        logwidget.cpp
        main.cpp
        midiworker.cpp
        midiarp.cpp
        midilfo.cpp
        midiseq.cpp
        midicctable.cpp
        midicontrol.cpp
        parstore.cpp
        prefswidget.cpp
        prefs.cpp
        jackdriver.cpp
        screen.cpp
        seqdriver.cpp
        slider.cpp
        storagebutton.cpp
    )
    set( DTRANSLATIONSDIR "")
    
    if (CONFIG_TRANSLATIONS)
        add_subdirectory(translations)
        set( DTRANSLATIONSDIR -DTRANSLATIONSDIR="${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/${PACKAGE}/translations/" )
    endif()
    
    add_executable (${PROJECT_NAME}
      ${HEADERS}
      ${SOURCES}
    )

    set_target_properties (${PROJECT_NAME} PROPERTIES CXX_STANDARD 11)
    target_compile_options(${PROJECT_NAME} PRIVATE -DAPPBUILD ${DTRANSLATIONSDIR})

    if (CONFIG_JACK_MIDI)
      target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::JACK)
    endif ()
    
    if (CONFIG_ALSA_MIDI)
      target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::ALSA)
    endif ()
    
    target_link_libraries (${PROJECT_NAME} PUBLIC   Qt${QT_VERSION_MAJOR}::Core 
                                                    Qt${QT_VERSION_MAJOR}::Gui
                                                    Qt${QT_VERSION_MAJOR}::Widgets
                                                    )
    
    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
        COMMAND strip ${PROJECT_NAME})
    endif ()

    install (TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

endif ()
#LV2 DSPs

if (BUILD_LV2)
    set(HEADERS_arp
        lv2_common.h
        main.h
        midiworker.h
        midiarp.h
        midiarp_lv2.h
    )
    
    set(SOURCES_arp
        midiworker.cpp
        midiarp.cpp
        midiarp_lv2.cpp
    )
    
    set(LV2_LFO_HEADERS
        lv2_common.h
        main.h
        midiworker.h
        midilfo.h
        midilfo_lv2.h
    )
    
    set(LV2_LFO_SOURCES
        midiworker.cpp
        midilfo.cpp
        midilfo_lv2.cpp
    )
    
    set(LV2_SEQ_HEADERS
        lv2_common.h
        main.h
        midiworker.h
        midiseq.h
        midiseq_lv2.h
    )
    
    set(LV2_SEQ_SOURCES
        midiworker.cpp
        midiseq.cpp
        midiseq_lv2.cpp
    )
    
    add_library (${PROJECT_NAME}_arp MODULE
      ${HEADERS_arp}
      ${SOURCES_arp}
    )
    
    add_library (${PROJECT_NAME}_lfo MODULE
      ${LV2_LFO_HEADERS}
      ${LV2_LFO_SOURCES}
    )
    
    add_library (${PROJECT_NAME}_seq MODULE
      ${LV2_SEQ_HEADERS}
      ${LV2_SEQ_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_arp PROPERTIES CXX_STANDARD 11 PREFIX "")
    set_target_properties (${PROJECT_NAME}_lfo PROPERTIES CXX_STANDARD 11 PREFIX "")
    set_target_properties (${PROJECT_NAME}_seq PROPERTIES CXX_STANDARD 11 PREFIX "")

    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_arp  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_arp.so)
      add_custom_command(TARGET ${PROJECT_NAME}_lfo  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_lfo.so)
      add_custom_command(TARGET ${PROJECT_NAME}_seq  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_seq.so)
    endif ()

    if (UNIX AND NOT APPLE)
      if (CONFIG_PREFIX MATCHES $ENV{HOME})
        set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
      endif ()
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_arp.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_lfo.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_lfo.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_seq.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_seq.lv2)
    endif ()
endif ()

# LV2 UIs
if (BUILD_LV2_UI)
    
    set(LV2UI_ARP_HEADERS
        cursor.h
        lv2_common.h
        main.h
        midiworker.h
        midiarp.h
        modulewidget.h
        arpwidget.h
        arpscreen.h
        screen.h
        slider.h
        arpwidget_lv2.h
    )
    
    set(LV2UI_ARP_SOURCES
        cursor.cpp
        midiworker.cpp
        midiarp.cpp
        modulewidget.cpp
        arpwidget.cpp
        arpscreen.cpp
        screen.cpp
        slider.cpp
        arpwidget_lv2.cpp
    )
    
    set(LV2UI_LFO_HEADERS
        cursor.h
        lv2_common.h
        main.h
        midiworker.h
        midilfo.h
        modulewidget.h
        lfowidget.h
        lfoscreen.h
        screen.h
        slider.h
        lfowidget_lv2.h
    )
    
    set(LV2UI_LFO_SOURCES
        cursor.cpp
        midiworker.cpp
        midilfo.cpp
        modulewidget.cpp
        lfowidget.cpp
        lfoscreen.cpp
        screen.cpp
        slider.cpp
        lfowidget_lv2.cpp
    )
    
    set(LV2UI_SEQ_HEADERS
        cursor.h
        lv2_common.h
        main.h
        midiworker.h
        midiseq.h
        modulewidget.h
        seqwidget.h
        seqscreen.h
        screen.h
        slider.h
        seqwidget_lv2.h
    )
    
    set(LV2UI_SEQ_SOURCES
        cursor.cpp
        midiworker.cpp
        midiseq.cpp
        modulewidget.cpp
        seqwidget.cpp
        seqscreen.cpp
        screen.cpp
        slider.cpp
        seqwidget_lv2.cpp
    )
    
    add_library (${PROJECT_NAME}_arp_ui MODULE
      ${LV2UI_ARP_HEADERS}
      ${LV2UI_ARP_SOURCES}
    )
    
    add_library (${PROJECT_NAME}_lfo_ui MODULE
      ${LV2UI_LFO_HEADERS}
      ${LV2UI_LFO_SOURCES}
    )
    
    add_library (${PROJECT_NAME}_seq_ui MODULE
      ${LV2UI_SEQ_HEADERS}
      ${LV2UI_SEQ_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_arp_ui PROPERTIES CXX_STANDARD 11 PREFIX "")
    set_target_properties (${PROJECT_NAME}_lfo_ui PROPERTIES CXX_STANDARD 11 PREFIX "")
    set_target_properties (${PROJECT_NAME}_seq_ui PROPERTIES CXX_STANDARD 11 PREFIX "")
    
    target_link_libraries (${PROJECT_NAME}_arp_ui PUBLIC   Qt${QT_VERSION_MAJOR}::Core 
                                                    Qt${QT_VERSION_MAJOR}::Gui
                                                    Qt${QT_VERSION_MAJOR}::Widgets
                                                    )
    
    target_link_libraries (${PROJECT_NAME}_lfo_ui PUBLIC   Qt${QT_VERSION_MAJOR}::Core 
                                                    Qt${QT_VERSION_MAJOR}::Gui
                                                    Qt${QT_VERSION_MAJOR}::Widgets
                                                    )
    
    target_link_libraries (${PROJECT_NAME}_seq_ui PUBLIC   Qt${QT_VERSION_MAJOR}::Core 
                                                    Qt${QT_VERSION_MAJOR}::Gui
                                                    Qt${QT_VERSION_MAJOR}::Widgets
                                                    )
    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_arp_ui  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_arp_ui.so)
      add_custom_command(TARGET ${PROJECT_NAME}_lfo_ui  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_lfo_ui.so)
      add_custom_command(TARGET ${PROJECT_NAME}_seq_ui  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_seq_ui.so)
    endif ()

    if (UNIX AND NOT APPLE)
      if (CONFIG_PREFIX MATCHES $ENV{HOME})
        set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
      endif ()
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_arp_ui.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_lfo_ui.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_lfo.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_seq_ui.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_seq.lv2)
    endif ()
    
endif()

# LV2 RobTk UIs
if (BUILD_LV2_UI_RTK)
    
    set(LV2UI_RTK_ARP_SOURCES
        ../robtk/pugl/pugl_x11.c
        ../robtk/ui_gl.c 
    )
  
    add_library (${PROJECT_NAME}_arp_ui_gl MODULE
      ${LV2UI_RTK_ARP_HEADERS}
      ${LV2UI_RTK_ARP_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_arp_ui_gl PROPERTIES C_STANDARD 11 PREFIX "")
    target_compile_options(${PROJECT_NAME}_arp_ui_gl PRIVATE   -g -Wall 
                                    -Wno-unused-function -DHAVE_LV2_1_8
                                    -DUSE_GUI_THREAD -pthread -DUINQHACK="168162529512469" 
                                    -DPLUGIN_SOURCE="arpwidget_lv2_rtk.c"
                                    -g -Wall -Wno-unused-function 
                                    -DHAVE_LV2_1_8 -I.. -I. 
                                    -pthread -DHAVE_IDLE_IFACE -I.
                                    )
    
    target_link_libraries (${PROJECT_NAME}_arp_ui_gl PUBLIC -lX11)

    set(LV2UI_RTK_LFO_SOURCES
        ../robtk/pugl/pugl_x11.c
        ../robtk/ui_gl.c 
    )
  
    add_library (${PROJECT_NAME}_lfo_ui_gl MODULE
      ${LV2UI_RTK_LFO_HEADERS}
      ${LV2UI_RTK_LFO_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_lfo_ui_gl PROPERTIES C_STANDARD 11 PREFIX "")
    target_compile_options(${PROJECT_NAME}_lfo_ui_gl PRIVATE   -g -Wall 
                                    -Wno-unused-function -DHAVE_LV2_1_8
                                    -DUSE_GUI_THREAD -pthread -DUINQHACK="168162529512469" 
                                    -DPLUGIN_SOURCE="lfowidget_lv2_rtk.c"
                                    -g -Wall -Wno-unused-function 
                                    -DHAVE_LV2_1_8 -I.. -I. 
                                    -pthread -DHAVE_IDLE_IFACE -I.
                                    )
    
    target_link_libraries (${PROJECT_NAME}_lfo_ui_gl PUBLIC -lX11)

    set(LV2UI_RTK_SEQ_SOURCES
        ../robtk/pugl/pugl_x11.c
        ../robtk/ui_gl.c 
    )
  
    add_library (${PROJECT_NAME}_seq_ui_gl MODULE
      ${LV2UI_RTK_SEQ_HEADERS}
      ${LV2UI_RTK_SEQ_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_seq_ui_gl PROPERTIES C_STANDARD 11 PREFIX "")
    target_compile_options(${PROJECT_NAME}_seq_ui_gl PRIVATE   -g -Wall 
                                    -Wno-unused-function -DHAVE_LV2_1_8
                                    -DUSE_GUI_THREAD -pthread -DUINQHACK="168162529512469" 
                                    -DPLUGIN_SOURCE="seqwidget_lv2_rtk.c"
                                    -g -Wall -Wno-unused-function 
                                    -DHAVE_LV2_1_8 -I.. -I. 
                                    -pthread -DHAVE_IDLE_IFACE -I.
                                    )
    
    target_link_libraries (${PROJECT_NAME}_seq_ui_gl PUBLIC -lX11)

    if (UNIX AND NOT APPLE)
      if (CONFIG_PREFIX MATCHES $ENV{HOME})

=== debian/changelog ===
qmidiarp (0.7.0+ds-1build4) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:22:02 +0000

qmidiarp (0.7.0+ds-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:06:14 +0000

qmidiarp (0.7.0+ds-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:41:05 +0000

qmidiarp (0.7.0+ds-1build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:01:20 +0000

qmidiarp (0.7.0+ds-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Archive, Repository.
  * Update standards version to 4.5.1, no changes needed.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Dennis Braun ]
  * New upstream version 0.7.0+ds
    + We use robtk from debian archive
  * d/control:
    + Add me as uploader
    + Bump dh-compat to 13
    + Mark libasound2-dev as linux-any
    + Add libjack-jackd2-dev as optional B-D
    + Bump Standards-Version to 4.6.2
    + Set RRR: no
  * d/copyright:
    + Bump d/copyright years
    + Add myself to the d/ section
  * Add salsa ci config
  * d/upstream/metadata: Point to github
  * Bump the d/watch version

 -- Dennis Braun <snd@debian.org>  Tue, 08 Aug 2023 21:25:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,26 @@
 Source: qmidiarp
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Alessio Treglia <alessio@debian.org>,
- Jaromír Mikeš <mira.mikes@seznam.cz>
-Build-Depends: debhelper (>= 10),
- dh-autoreconf,
+ Jaromír Mikeš <mira.mikes@seznam.cz>,
+ Dennis Braun <snd@debian.org>
+Build-Depends: debhelper-compat (= 13),
+ dh-sequence-scour,
  lv2-dev,
  qtbase5-dev,
  qttools5-dev-tools,
- libasound2-dev,
- libjack-dev,
+ libasound2-dev [linux-any],
+ libjack-dev | libjack-jackd2-dev,
  libx11-dev,
  liblo-dev,
- python-scour
-Homepage: http://qmidiarp.sourceforge.net/
-Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/qmidiarp.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/qmidiarp.git
+ robtk
+Rules-Requires-Root: no
+Standards-Version: 4.6.2
+Homepage: https://qmidiarp.sourceforge.io
+Vcs-Git: https://salsa.debian.org/multimedia-team/qmidiarp.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/qmidiarp
 
 Package: qmidiarp
 Architecture: any
@@ -48,5 +51,5 @@
  a JACK transport client. Most of the relevant control elements are
  accessible via MIDI controller through a MIDI-learn infrastructure.
  QMidiArp also has a log tool displaying the history of incoming MIDI
- events in colors depending on their type. QMidiArp is based on the Qt4
- toolkit
+ events in colors depending on their type. QMidiArp is based on the Qt
+ toolkit.
